aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorEric Biggers <ebiggers@google.com>2018-04-23 16:29:06 -0700
committerEric Biggers <ebiggers@google.com>2018-04-23 16:29:06 -0700
commit5ee555b6db7fc5a376410339f470b7b5df17da74 (patch)
tree9901825eb94e49718bdb5ad4cdf43734a07783f8
parent67cb57e51e508d00e8bc24b59d8a2e29cb19b3e0 (diff)
downloadxfstests-fsverity.tar.gz
generic: test that fs-verity inodes are unpinned on deletionfsverity
Signed-off-by: Eric Biggers <ebiggers@google.com>
-rw-r--r--tests/generic/90778
-rw-r--r--tests/generic/907.out2
-rw-r--r--tests/generic/group1
3 files changed, 81 insertions, 0 deletions
diff --git a/tests/generic/907 b/tests/generic/907
new file mode 100644
index 0000000000..33c18038a0
--- /dev/null
+++ b/tests/generic/907
@@ -0,0 +1,78 @@
+#! /bin/bash
+# FS QA Test generic/907
+#
+# Test that fs-verity inodes are unpinned on deletion
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Google, Inc. All Rights Reserved.
+#
+# Author: Eric Biggers <ebiggers@google.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/verity
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch_verity
+
+_scratch_mkfs_verity &>> $seqres.full
+_scratch_mount
+
+fsv_orig_file=$tmp.file
+fsv_file=$SCRATCH_MNT/file.fsv
+blocks=1024
+
+# Set up an fs-verity file within the encrypted directory.
+# Verity that it actually has an encryption policy.
+head -c $(( 1024 * blocks )) /dev/zero > $fsv_orig_file
+measurement=$(_fsv_setup_file $fsv_orig_file $fsv_file)
+$FSVERITY_PROG enable $fsv_file
+$FSVERITY_PROG set_measurement $fsv_file $measurement
+
+space_before=$(df -P $SCRATCH_DEV | awk 'END {print $4}')
+rm $fsv_file
+space_after=$(df -P $SCRATCH_DEV | awk 'END {print $4}')
+
+if (( space_after - space_before < blocks )); then
+ _fail "Space wasn't freed! space_before=$space_before, space_after=$space_after, blocks=$blocks"
+fi
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/generic/907.out b/tests/generic/907.out
new file mode 100644
index 0000000000..e25f6903cd
--- /dev/null
+++ b/tests/generic/907.out
@@ -0,0 +1,2 @@
+QA output created by 907
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 7d32e245e4..093f510c32 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -493,3 +493,4 @@
904 auto quick verity
905 auto quick verity
906 auto quick verity encrypt
+907 auto quick verity